# load APMonitor package
from apm import *
import numpy as np

# Set up problem
s = 'http://byu.apmonitor.com'
a = '2nd_order'
apm(s,a,'clear all')
apm_load(s,a,'2nd_order.apm')
csv_load(s,a,'2nd_order.csv')
apm_option(s,a,'nlc.imode',5)
apm_option(s,a,'nlc.nodes',3)
apm_info(s,a,'MV','c')
apm_option(s,a,'c.status',1)
apm_option(s,a,'c.dcost',1e-5)
apm_option(s,a,'c.mv_step_hor',10)

# Estimate parameters
output = apm(s,a,'solve')
print(output)
z = apm_sol(s,a)

# plot results
import matplotlib.pyplot as plt
plt.figure(1)
plt.subplot(2,1,1)
plt.plot(z['time'],z['y'],'r-',linewidth=3)
plt.plot(z['time'],z['ym'],'b.')
plt.plot(z['time'],z['dy'],'b--',linewidth=2)
plt.legend(['y (Predicted)','y (Measured)','dy/dt'],loc=4)
plt.subplot(2,1,2)
time = np.linspace(0,2,50)
c = (0.9+0.7*time)
plt.plot(z['time'],z['c'],'k--',linewidth=2)
plt.plot(time,c,'r:',linewidth=2)
plt.legend(['Estimated c','Actual c'],loc=4)
plt.xlabel('Time')
plt.show()
